int sockinit()
{
	struct hostent *hp;
	struct sockaddr_in sin;
	int i;

#ifdef WIN32
	if (WSAStartup(0x202, &wsaData)) {
		MessageBox(0, "Winsock 2 initialization failed.", APPTITLE, MB_ICONERROR);
		WSACleanup();
		exit(0);
	}
#else
	printf("Binding to 'http://%s:%d/'...", config.server_hostname, config.server_port);
	fflush(stdout);
#endif
	ListenSocket=socket(AF_INET, SOCK_STREAM, 0);
	memset((char *)&sin, 0, sizeof(sin));
	sin.sin_family=AF_INET;
	if (strcasecmp("ANY", config.server_hostname)==0) {
		sin.sin_addr.s_addr=htonl(INADDR_ANY);
	} else {
		hp=gethostbyname(config.server_hostname);
		memmove((char *)&sin.sin_addr, hp->h_addr, hp->h_length);
	}
	sin.sin_port=htons((unsigned short)config.server_port);
	i=0;
	while (bind(ListenSocket, (struct sockaddr *)&sin, sizeof(sin))<0) {
		sleep(5);
		i++;
		if (i>6) {
			logerror("bind() error [%s:%d]", config.server_hostname, config.server_port);
#ifdef WIN32
			MessageBox(0, "Bind error: Null httpd could not bind itself to the specified port.", APPTITLE, MB_ICONERROR);
#else
			perror("\nBind error");
#endif
			exit(0);
		}
	}
	if (listen(ListenSocket, 50)<0) {
		logerror("listen() error");
#ifdef WIN32
		closesocket(ListenSocket);
#else
		close(ListenSocket);
#endif
		exit(0);
	}
#ifndef WIN32
	printf("OK.\r\n");
	daemon(0, 0);
#endif
	setsigs();
	return 0;
}
